package org.omg.Security;

/** 
 * Helper class for : AuditEventType
 *  
 * @author OpenORB Compiler
 */ 
public class AuditEventTypeHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert AuditEventType into an any
     * @param a an any
     * @param t AuditEventType value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.AuditEventType t)
    {
        a.insert_Streamable(new org.omg.Security.AuditEventTypeHolder(t));
    }

    /**
     * Extract AuditEventType from an any
     * @param a an any
     * @return the extracted AuditEventType value
     */
    public static org.omg.Security.AuditEventType extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if (HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.AuditEventTypeHolder)
                    return ((org.omg.Security.AuditEventTypeHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.AuditEventTypeHolder h = new org.omg.Security.AuditEventTypeHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;
    private static boolean _working = false;

    /**
     * Return the AuditEventType TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (_tc != null)
                    return _tc;
                if (_working)
                    return org.omg.CORBA.ORB.init().create_recursive_tc(id());
                _working = true;
                org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
                org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

                _members[0] = new org.omg.CORBA.StructMember();
                _members[0].name = "event_family";
                _members[0].type = org.omg.Security.ExtensibleFamilyHelper.type();
                _members[1] = new org.omg.CORBA.StructMember();
                _members[1].name = "event_type";
                _members[1].type = org.omg.Security.EventTypeHelper.type();
                _tc = orb.create_struct_tc(id(),"AuditEventType",_members);
                _working = false;
            }
        }
        return _tc;
    }

    /**
     * Return the AuditEventType IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/AuditEventType:1.0";

    /**
     * Read AuditEventType from a marshalled stream
     * @param istream the input stream
     * @return the readed AuditEventType value
     */
    public static org.omg.Security.AuditEventType read(org.omg.CORBA.portable.InputStream istream)
    {
        org.omg.Security.AuditEventType new_one = new org.omg.Security.AuditEventType();

        new_one.event_family = org.omg.Security.ExtensibleFamilyHelper.read(istream);
        new_one.event_type = org.omg.Security.EventTypeHelper.read(istream);

        return new_one;
    }

    /**
     * Write AuditEventType into a marshalled stream
     * @param ostream the output stream
     * @param value AuditEventType value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.AuditEventType value)
    {
        org.omg.Security.ExtensibleFamilyHelper.write(ostream,value.event_family);
        org.omg.Security.EventTypeHelper.write(ostream,value.event_type);
    }

}
