package org.omg.Security;

/** 
 * Helper class for : AuthenticationMethodList
 *  
 * @author OpenORB Compiler
 */ 
public class AuthenticationMethodListHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert AuthenticationMethodList into an any
     * @param a an any
     * @param t AuthenticationMethodList value
     */
    public static void insert(org.omg.CORBA.Any a, int[] t)
    {
        a.insert_Streamable(new org.omg.Security.AuthenticationMethodListHolder(t));
    }

    /**
     * Extract AuthenticationMethodList from an any
     * @param a an any
     * @return the extracted AuthenticationMethodList value
     */
    public static int[] extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if(HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.AuthenticationMethodListHolder)
                    return ((org.omg.Security.AuthenticationMethodListHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.AuthenticationMethodListHolder h = new org.omg.Security.AuthenticationMethodListHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;

    /**
     * Return the AuthenticationMethodList TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
            _tc = orb.create_alias_tc(id(),"AuthenticationMethodList",orb.create_sequence_tc(0,org.omg.Security.AuthenticationMethodHelper.type()));
        }
        return _tc;
    }

    /**
     * Return the AuthenticationMethodList IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/AuthenticationMethodList:1.0";

    /**
     * Read AuthenticationMethodList from a marshalled stream
     * @param istream the input stream
     * @return the readed AuthenticationMethodList value
     */
    public static int[] read(org.omg.CORBA.portable.InputStream istream)
    {
        int[] new_one;
        {
        int size7 = istream.read_ulong();
        new_one = new int[size7];
        istream.read_ulong_array(new_one, 0, new_one.length);
        }

        return new_one;
    }

    /**
     * Write AuthenticationMethodList into a marshalled stream
     * @param ostream the output stream
     * @param value AuthenticationMethodList value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, int[] value)
    {
        ostream.write_ulong(value.length);
        ostream.write_ulong_array(value, 0,value.length);
    }

}
