package org.omg.Security;

/** 
 * Helper class for : ChannelBindings
 *  
 * @author OpenORB Compiler
 */ 
public class ChannelBindingsHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert ChannelBindings into an any
     * @param a an any
     * @param t ChannelBindings value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.ChannelBindings t)
    {
        a.insert_Streamable(new org.omg.Security.ChannelBindingsHolder(t));
    }

    /**
     * Extract ChannelBindings from an any
     * @param a an any
     * @return the extracted ChannelBindings value
     */
    public static org.omg.Security.ChannelBindings extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if (HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.ChannelBindingsHolder)
                    return ((org.omg.Security.ChannelBindingsHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.ChannelBindingsHolder h = new org.omg.Security.ChannelBindingsHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;
    private static boolean _working = false;

    /**
     * Return the ChannelBindings TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (_tc != null)
                    return _tc;
                if (_working)
                    return org.omg.CORBA.ORB.init().create_recursive_tc(id());
                _working = true;
                org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
                org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[5];

                _members[0] = new org.omg.CORBA.StructMember();
                _members[0].name = "initiator_addrtype";
                _members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
                _members[1] = new org.omg.CORBA.StructMember();
                _members[1].name = "initiator_address";
                _members[1].type = orb.create_sequence_tc(0,orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet));
                _members[2] = new org.omg.CORBA.StructMember();
                _members[2].name = "acceptor_addrtype";
                _members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
                _members[3] = new org.omg.CORBA.StructMember();
                _members[3].name = "acceptor_address";
                _members[3].type = orb.create_sequence_tc(0,orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet));
                _members[4] = new org.omg.CORBA.StructMember();
                _members[4].name = "application_data";
                _members[4].type = orb.create_sequence_tc(0,orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_octet));
                _tc = orb.create_struct_tc(id(),"ChannelBindings",_members);
                _working = false;
            }
        }
        return _tc;
    }

    /**
     * Return the ChannelBindings IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/ChannelBindings:1.0";

    /**
     * Read ChannelBindings from a marshalled stream
     * @param istream the input stream
     * @return the readed ChannelBindings value
     */
    public static org.omg.Security.ChannelBindings read(org.omg.CORBA.portable.InputStream istream)
    {
        org.omg.Security.ChannelBindings new_one = new org.omg.Security.ChannelBindings();

        new_one.initiator_addrtype = istream.read_ulong();
        {
        int size7 = istream.read_ulong();
        new_one.initiator_address = new byte[size7];
        istream.read_octet_array(new_one.initiator_address, 0, new_one.initiator_address.length);
        }
        new_one.acceptor_addrtype = istream.read_ulong();
        {
        int size7 = istream.read_ulong();
        new_one.acceptor_address = new byte[size7];
        istream.read_octet_array(new_one.acceptor_address, 0, new_one.acceptor_address.length);
        }
        {
        int size7 = istream.read_ulong();
        new_one.application_data = new byte[size7];
        istream.read_octet_array(new_one.application_data, 0, new_one.application_data.length);
        }

        return new_one;
    }

    /**
     * Write ChannelBindings into a marshalled stream
     * @param ostream the output stream
     * @param value ChannelBindings value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.ChannelBindings value)
    {
        ostream.write_ulong(value.initiator_addrtype);
        ostream.write_ulong(value.initiator_address.length);
        ostream.write_octet_array(value.initiator_address, 0,value.initiator_address.length);
        ostream.write_ulong(value.acceptor_addrtype);
        ostream.write_ulong(value.acceptor_address.length);
        ostream.write_octet_array(value.acceptor_address, 0,value.acceptor_address.length);
        ostream.write_ulong(value.application_data.length);
        ostream.write_octet_array(value.application_data, 0,value.application_data.length);
    }

}
