package org.omg.Security;

/** 
 * Helper class for : EstablishTrust
 *  
 * @author OpenORB Compiler
 */ 
public class EstablishTrustHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert EstablishTrust into an any
     * @param a an any
     * @param t EstablishTrust value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.EstablishTrust t)
    {
        a.insert_Streamable(new org.omg.Security.EstablishTrustHolder(t));
    }

    /**
     * Extract EstablishTrust from an any
     * @param a an any
     * @return the extracted EstablishTrust value
     */
    public static org.omg.Security.EstablishTrust extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if (HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.EstablishTrustHolder)
                    return ((org.omg.Security.EstablishTrustHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.EstablishTrustHolder h = new org.omg.Security.EstablishTrustHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;
    private static boolean _working = false;

    /**
     * Return the EstablishTrust TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (_tc != null)
                    return _tc;
                if (_working)
                    return org.omg.CORBA.ORB.init().create_recursive_tc(id());
                _working = true;
                org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
                org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

                _members[0] = new org.omg.CORBA.StructMember();
                _members[0].name = "trust_in_client";
                _members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
                _members[1] = new org.omg.CORBA.StructMember();
                _members[1].name = "trust_in_target";
                _members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean);
                _tc = orb.create_struct_tc(id(),"EstablishTrust",_members);
                _working = false;
            }
        }
        return _tc;
    }

    /**
     * Return the EstablishTrust IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/EstablishTrust:1.0";

    /**
     * Read EstablishTrust from a marshalled stream
     * @param istream the input stream
     * @return the readed EstablishTrust value
     */
    public static org.omg.Security.EstablishTrust read(org.omg.CORBA.portable.InputStream istream)
    {
        org.omg.Security.EstablishTrust new_one = new org.omg.Security.EstablishTrust();

        new_one.trust_in_client = istream.read_boolean();
        new_one.trust_in_target = istream.read_boolean();

        return new_one;
    }

    /**
     * Write EstablishTrust into a marshalled stream
     * @param ostream the output stream
     * @param value EstablishTrust value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.EstablishTrust value)
    {
        ostream.write_boolean(value.trust_in_client);
        ostream.write_boolean(value.trust_in_target);
    }

}
