package org.omg.Security;

/** 
 * Helper class for : ExtensibleFamily
 *  
 * @author OpenORB Compiler
 */ 
public class ExtensibleFamilyHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert ExtensibleFamily into an any
     * @param a an any
     * @param t ExtensibleFamily value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.ExtensibleFamily t)
    {
        a.insert_Streamable(new org.omg.Security.ExtensibleFamilyHolder(t));
    }

    /**
     * Extract ExtensibleFamily from an any
     * @param a an any
     * @return the extracted ExtensibleFamily value
     */
    public static org.omg.Security.ExtensibleFamily extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if (HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.ExtensibleFamilyHolder)
                    return ((org.omg.Security.ExtensibleFamilyHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.ExtensibleFamilyHolder h = new org.omg.Security.ExtensibleFamilyHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;
    private static boolean _working = false;

    /**
     * Return the ExtensibleFamily TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (_tc != null)
                    return _tc;
                if (_working)
                    return org.omg.CORBA.ORB.init().create_recursive_tc(id());
                _working = true;
                org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
                org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

                _members[0] = new org.omg.CORBA.StructMember();
                _members[0].name = "family_definer";
                _members[0].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ushort);
                _members[1] = new org.omg.CORBA.StructMember();
                _members[1].name = "family";
                _members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ushort);
                _tc = orb.create_struct_tc(id(),"ExtensibleFamily",_members);
                _working = false;
            }
        }
        return _tc;
    }

    /**
     * Return the ExtensibleFamily IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/ExtensibleFamily:1.0";

    /**
     * Read ExtensibleFamily from a marshalled stream
     * @param istream the input stream
     * @return the readed ExtensibleFamily value
     */
    public static org.omg.Security.ExtensibleFamily read(org.omg.CORBA.portable.InputStream istream)
    {
        org.omg.Security.ExtensibleFamily new_one = new org.omg.Security.ExtensibleFamily();

        new_one.family_definer = istream.read_ushort();
        new_one.family = istream.read_ushort();

        return new_one;
    }

    /**
     * Write ExtensibleFamily into a marshalled stream
     * @param ostream the output stream
     * @param value ExtensibleFamily value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.ExtensibleFamily value)
    {
        ostream.write_ushort(value.family_definer);
        ostream.write_ushort(value.family);
    }

}
