package org.omg.Security;

/** 
 * Helper class for : MechandOptions
 *  
 * @author OpenORB Compiler
 */ 
public class MechandOptionsHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert MechandOptions into an any
     * @param a an any
     * @param t MechandOptions value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.MechandOptions t)
    {
        a.insert_Streamable(new org.omg.Security.MechandOptionsHolder(t));
    }

    /**
     * Extract MechandOptions from an any
     * @param a an any
     * @return the extracted MechandOptions value
     */
    public static org.omg.Security.MechandOptions extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if (HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.MechandOptionsHolder)
                    return ((org.omg.Security.MechandOptionsHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.MechandOptionsHolder h = new org.omg.Security.MechandOptionsHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;
    private static boolean _working = false;

    /**
     * Return the MechandOptions TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (_tc != null)
                    return _tc;
                if (_working)
                    return org.omg.CORBA.ORB.init().create_recursive_tc(id());
                _working = true;
                org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
                org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

                _members[0] = new org.omg.CORBA.StructMember();
                _members[0].name = "mechanism_type";
                _members[0].type = org.omg.Security.MechanismTypeHelper.type();
                _members[1] = new org.omg.CORBA.StructMember();
                _members[1].name = "options_supported";
                _members[1].type = org.omg.Security.AssociationOptionsHelper.type();
                _tc = orb.create_struct_tc(id(),"MechandOptions",_members);
                _working = false;
            }
        }
        return _tc;
    }

    /**
     * Return the MechandOptions IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/MechandOptions:1.0";

    /**
     * Read MechandOptions from a marshalled stream
     * @param istream the input stream
     * @return the readed MechandOptions value
     */
    public static org.omg.Security.MechandOptions read(org.omg.CORBA.portable.InputStream istream)
    {
        org.omg.Security.MechandOptions new_one = new org.omg.Security.MechandOptions();

        new_one.mechanism_type = org.omg.Security.MechanismTypeHelper.read(istream);
        new_one.options_supported = org.omg.Security.AssociationOptionsHelper.read(istream);

        return new_one;
    }

    /**
     * Write MechandOptions into a marshalled stream
     * @param ostream the output stream
     * @param value MechandOptions value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.MechandOptions value)
    {
        org.omg.Security.MechanismTypeHelper.write(ostream,value.mechanism_type);
        org.omg.Security.AssociationOptionsHelper.write(ostream,value.options_supported);
    }

}
