package org.omg.Security;

/** 
 * Helper class for : OpaqueBuffer
 *  
 * @author OpenORB Compiler
 */ 
public class OpaqueBufferHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert OpaqueBuffer into an any
     * @param a an any
     * @param t OpaqueBuffer value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.OpaqueBuffer t)
    {
        a.insert_Streamable(new org.omg.Security.OpaqueBufferHolder(t));
    }

    /**
     * Extract OpaqueBuffer from an any
     * @param a an any
     * @return the extracted OpaqueBuffer value
     */
    public static org.omg.Security.OpaqueBuffer extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if (HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.OpaqueBufferHolder)
                    return ((org.omg.Security.OpaqueBufferHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.OpaqueBufferHolder h = new org.omg.Security.OpaqueBufferHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;
    private static boolean _working = false;

    /**
     * Return the OpaqueBuffer TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (_tc != null)
                    return _tc;
                if (_working)
                    return org.omg.CORBA.ORB.init().create_recursive_tc(id());
                _working = true;
                org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
                org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

                _members[0] = new org.omg.CORBA.StructMember();
                _members[0].name = "buffer";
                _members[0].type = org.omg.Security.OpaqueHelper.type();
                _members[1] = new org.omg.CORBA.StructMember();
                _members[1].name = "startpos";
                _members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
                _members[2] = new org.omg.CORBA.StructMember();
                _members[2].name = "endpos";
                _members[2].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_ulong);
                _tc = orb.create_struct_tc(id(),"OpaqueBuffer",_members);
                _working = false;
            }
        }
        return _tc;
    }

    /**
     * Return the OpaqueBuffer IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/OpaqueBuffer:1.0";

    /**
     * Read OpaqueBuffer from a marshalled stream
     * @param istream the input stream
     * @return the readed OpaqueBuffer value
     */
    public static org.omg.Security.OpaqueBuffer read(org.omg.CORBA.portable.InputStream istream)
    {
        org.omg.Security.OpaqueBuffer new_one = new org.omg.Security.OpaqueBuffer();

        new_one.buffer = org.omg.Security.OpaqueHelper.read(istream);
        new_one.startpos = istream.read_ulong();
        new_one.endpos = istream.read_ulong();

        return new_one;
    }

    /**
     * Write OpaqueBuffer into a marshalled stream
     * @param ostream the output stream
     * @param value OpaqueBuffer value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.OpaqueBuffer value)
    {
        org.omg.Security.OpaqueHelper.write(ostream,value.buffer);
        ostream.write_ulong(value.startpos);
        ostream.write_ulong(value.endpos);
    }

}
