package org.omg.Security;

/** 
 * Helper class for : QOP
 *  
 * @author OpenORB Compiler
 */ 
public class QOPHelper
{
    /**
     * Insert QOP into an any
     * @param a an any
     * @param t QOP value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.QOP t)
    {
        a.type(type());
        write(a.create_output_stream(),t);
    }

    /**
     * Extract QOP from an any
     * @param a an any
     * @return the extracted QOP value
     */
    public static org.omg.Security.QOP extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;

    /**
     * Return the QOP TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
            String []_members = new String[4];
            _members[0] = "SecQOPNoProtection";
            _members[1] = "SecQOPIntegrity";
            _members[2] = "SecQOPConfidentiality";
            _members[3] = "SecQOPIntegrityAndConfidentiality";
            _tc = orb.create_enum_tc(id(),"QOP",_members);
        }
        return _tc;
    }

    /**
     * Return the QOP IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/QOP:1.0";

    /**
     * Read QOP from a marshalled stream
     * @param istream the input stream
     * @return the readed QOP value
     */
    public static org.omg.Security.QOP read(org.omg.CORBA.portable.InputStream istream)
    {
        return QOP.from_int(istream.read_ulong());
    }

    /**
     * Write QOP into a marshalled stream
     * @param ostream the output stream
     * @param value QOP value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.QOP value)
    {
        ostream.write_ulong(value.value());
    }

}
