package org.omg.Security;

/** 
 * Helper class for : SecAttribute
 *  
 * @author OpenORB Compiler
 */ 
public class SecAttributeHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert SecAttribute into an any
     * @param a an any
     * @param t SecAttribute value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.SecAttribute t)
    {
        a.insert_Streamable(new org.omg.Security.SecAttributeHolder(t));
    }

    /**
     * Extract SecAttribute from an any
     * @param a an any
     * @return the extracted SecAttribute value
     */
    public static org.omg.Security.SecAttribute extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if (HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.SecAttributeHolder)
                    return ((org.omg.Security.SecAttributeHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.SecAttributeHolder h = new org.omg.Security.SecAttributeHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;
    private static boolean _working = false;

    /**
     * Return the SecAttribute TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (_tc != null)
                    return _tc;
                if (_working)
                    return org.omg.CORBA.ORB.init().create_recursive_tc(id());
                _working = true;
                org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
                org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[3];

                _members[0] = new org.omg.CORBA.StructMember();
                _members[0].name = "attribute_type";
                _members[0].type = org.omg.Security.AttributeTypeHelper.type();
                _members[1] = new org.omg.CORBA.StructMember();
                _members[1].name = "defining_authority";
                _members[1].type = org.omg.Security.OIDHelper.type();
                _members[2] = new org.omg.CORBA.StructMember();
                _members[2].name = "value";
                _members[2].type = org.omg.Security.OpaqueHelper.type();
                _tc = orb.create_struct_tc(id(),"SecAttribute",_members);
                _working = false;
            }
        }
        return _tc;
    }

    /**
     * Return the SecAttribute IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/SecAttribute:1.0";

    /**
     * Read SecAttribute from a marshalled stream
     * @param istream the input stream
     * @return the readed SecAttribute value
     */
    public static org.omg.Security.SecAttribute read(org.omg.CORBA.portable.InputStream istream)
    {
        org.omg.Security.SecAttribute new_one = new org.omg.Security.SecAttribute();

        new_one.attribute_type = org.omg.Security.AttributeTypeHelper.read(istream);
        new_one.defining_authority = org.omg.Security.OIDHelper.read(istream);
        new_one.value = org.omg.Security.OpaqueHelper.read(istream);

        return new_one;
    }

    /**
     * Write SecAttribute into a marshalled stream
     * @param ostream the output stream
     * @param value SecAttribute value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.SecAttribute value)
    {
        org.omg.Security.AttributeTypeHelper.write(ostream,value.attribute_type);
        org.omg.Security.OIDHelper.write(ostream,value.defining_authority);
        org.omg.Security.OpaqueHelper.write(ostream,value.value);
    }

}
