package org.omg.Security;

/** 
 * Helper class for : SecurityFeature
 *  
 * @author OpenORB Compiler
 */ 
public class SecurityFeatureHelper
{
    /**
     * Insert SecurityFeature into an any
     * @param a an any
     * @param t SecurityFeature value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.SecurityFeature t)
    {
        a.type(type());
        write(a.create_output_stream(),t);
    }

    /**
     * Extract SecurityFeature from an any
     * @param a an any
     * @return the extracted SecurityFeature value
     */
    public static org.omg.Security.SecurityFeature extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;

    /**
     * Return the SecurityFeature TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
            String []_members = new String[11];
            _members[0] = "SecNoDelegation";
            _members[1] = "SecSimpleDelegation";
            _members[2] = "SecCompositeDelegation";
            _members[3] = "SecNoProtection";
            _members[4] = "SecIntegrity";
            _members[5] = "SecConfidentiality";
            _members[6] = "SecIntegrityAndConfidentiality";
            _members[7] = "SecDetectReplay";
            _members[8] = "SecDetectMisordering";
            _members[9] = "SecEstablishTrustInTarget";
            _members[10] = "SecEstablishTrustInClient";
            _tc = orb.create_enum_tc(id(),"SecurityFeature",_members);
        }
        return _tc;
    }

    /**
     * Return the SecurityFeature IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/SecurityFeature:1.0";

    /**
     * Read SecurityFeature from a marshalled stream
     * @param istream the input stream
     * @return the readed SecurityFeature value
     */
    public static org.omg.Security.SecurityFeature read(org.omg.CORBA.portable.InputStream istream)
    {
        return SecurityFeature.from_int(istream.read_ulong());
    }

    /**
     * Write SecurityFeature into a marshalled stream
     * @param ostream the output stream
     * @param value SecurityFeature value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.SecurityFeature value)
    {
        ostream.write_ulong(value.value());
    }

}
