package org.omg.Security;

/** 
 * Helper class for : SelectorValue
 *  
 * @author OpenORB Compiler
 */ 
public class SelectorValueHelper
{
    private static final boolean HAS_OPENORB;
    static {
        boolean hasOpenORB = false;
        try {
            Thread.currentThread().getContextClassLoader().loadClass("org.openorb.CORBA.Any");
            hasOpenORB = true;
        }
        catch(ClassNotFoundException ex) {
        }
        HAS_OPENORB = hasOpenORB;
    }
    /**
     * Insert SelectorValue into an any
     * @param a an any
     * @param t SelectorValue value
     */
    public static void insert(org.omg.CORBA.Any a, org.omg.Security.SelectorValue t)
    {
        a.insert_Streamable(new org.omg.Security.SelectorValueHolder(t));
    }

    /**
     * Extract SelectorValue from an any
     * @param a an any
     * @return the extracted SelectorValue value
     */
    public static org.omg.Security.SelectorValue extract(org.omg.CORBA.Any a)
    {
        if (!a.type().equal(type()))
            throw new org.omg.CORBA.MARSHAL();
        if (HAS_OPENORB && a instanceof org.openorb.CORBA.Any) {
            // streamable extraction. The jdk stubs incorrectly define the Any stub
            org.openorb.CORBA.Any any = (org.openorb.CORBA.Any)a;
            try {
                org.omg.CORBA.portable.Streamable s = any.extract_Streamable();
                if(s instanceof org.omg.Security.SelectorValueHolder)
                    return ((org.omg.Security.SelectorValueHolder)s).value;
            } catch (org.omg.CORBA.BAD_INV_ORDER ex) {
            }
            org.omg.Security.SelectorValueHolder h = new org.omg.Security.SelectorValueHolder(read(a.create_input_stream()));
            a.insert_Streamable(h);
            return h.value;
        }
        return read(a.create_input_stream());
    }

    //
    // Internal TypeCode value
    //
    private static org.omg.CORBA.TypeCode _tc = null;
    private static boolean _working = false;

    /**
     * Return the SelectorValue TypeCode
     * @return a TypeCode
     */
    public static org.omg.CORBA.TypeCode type()
    {
        if (_tc == null) {
            synchronized(org.omg.CORBA.TypeCode.class) {
                if (_tc != null)
                    return _tc;
                if (_working)
                    return org.omg.CORBA.ORB.init().create_recursive_tc(id());
                _working = true;
                org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
                org.omg.CORBA.StructMember []_members = new org.omg.CORBA.StructMember[2];

                _members[0] = new org.omg.CORBA.StructMember();
                _members[0].name = "selector";
                _members[0].type = org.omg.Security.SelectorTypeHelper.type();
                _members[1] = new org.omg.CORBA.StructMember();
                _members[1].name = "value";
                _members[1].type = orb.get_primitive_tc(org.omg.CORBA.TCKind.tk_any);
                _tc = orb.create_struct_tc(id(),"SelectorValue",_members);
                _working = false;
            }
        }
        return _tc;
    }

    /**
     * Return the SelectorValue IDL ID
     * @return an ID
     */
    public static String id()
    {
        return _id;
    }

    private final static String _id = "IDL:omg.org/Security/SelectorValue:1.0";

    /**
     * Read SelectorValue from a marshalled stream
     * @param istream the input stream
     * @return the readed SelectorValue value
     */
    public static org.omg.Security.SelectorValue read(org.omg.CORBA.portable.InputStream istream)
    {
        org.omg.Security.SelectorValue new_one = new org.omg.Security.SelectorValue();

        new_one.selector = org.omg.Security.SelectorTypeHelper.read(istream);
        new_one.value = istream.read_any();

        return new_one;
    }

    /**
     * Write SelectorValue into a marshalled stream
     * @param ostream the output stream
     * @param value SelectorValue value
     */
    public static void write(org.omg.CORBA.portable.OutputStream ostream, org.omg.Security.SelectorValue value)
    {
        org.omg.Security.SelectorTypeHelper.write(ostream,value.selector);
        ostream.write_any(value.value);
    }

}
