package org.omg.SecurityLevel2;

/**
 * Interface definition : Credentials
 * 
 * @author OpenORB Compiler
 */
public abstract class CredentialsPOA extends org.omg.PortableServer.Servant
        implements CredentialsOperations, org.omg.CORBA.portable.InvokeHandler
{
    public Credentials _this()
    {
        return CredentialsHelper.narrow(_this_object());
    }

    public Credentials _this(org.omg.CORBA.ORB orb)
    {
        return CredentialsHelper.narrow(_this_object(orb));
    }

    private static String [] _ids_list =
    {
        "IDL:omg.org/SecurityLevel2/Credentials:1.8"
    };

    public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte [] objectId)
    {
        return _ids_list;
    }

    private static final java.util.Map operationMap = new java.util.HashMap();

    static {
            operationMap.put("_get_accepting_options_required",
                    new Operation__get_accepting_options_required());
            operationMap.put("_get_accepting_options_supported",
                    new Operation__get_accepting_options_supported());
            operationMap.put("_get_authentication_state",
                    new Operation__get_authentication_state());
            operationMap.put("_get_credentials_type",
                    new Operation__get_credentials_type());
            operationMap.put("_get_invocation_options_required",
                    new Operation__get_invocation_options_required());
            operationMap.put("_get_invocation_options_supported",
                    new Operation__get_invocation_options_supported());
            operationMap.put("_get_mechanism",
                    new Operation__get_mechanism());
            operationMap.put("_set_accepting_options_required",
                    new Operation__set_accepting_options_required());
            operationMap.put("_set_accepting_options_supported",
                    new Operation__set_accepting_options_supported());
            operationMap.put("_set_invocation_options_required",
                    new Operation__set_invocation_options_required());
            operationMap.put("_set_invocation_options_supported",
                    new Operation__set_invocation_options_supported());
            operationMap.put("copy",
                    new Operation_copy());
            operationMap.put("destroy",
                    new Operation_destroy());
            operationMap.put("get_attributes",
                    new Operation_get_attributes());
            operationMap.put("get_security_feature",
                    new Operation_get_security_feature());
            operationMap.put("is_valid",
                    new Operation_is_valid());
            operationMap.put("refresh",
                    new Operation_refresh());
            operationMap.put("set_attributes",
                    new Operation_set_attributes());
    }

    public final org.omg.CORBA.portable.OutputStream _invoke(final String opName,
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler)
    {

        final AbstractOperation operation = (AbstractOperation)operationMap.get(opName);

        if (null == operation) {
            throw new org.omg.CORBA.BAD_OPERATION(opName);
        }

        return operation.invoke(this, _is, handler);
    }

    // helper methods
    private org.omg.CORBA.portable.OutputStream _invoke_copy(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;

        org.omg.SecurityLevel2.Credentials _arg_result = copy();

        _output = handler.createReply();
        org.omg.SecurityLevel2.CredentialsHelper.write(_output,_arg_result);

        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_destroy(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;

        destroy();

        _output = handler.createReply();

        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_credentials_type(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.Security.InvocationCredentialsType arg = credentials_type();
        _output = handler.createReply();
        org.omg.Security.InvocationCredentialsTypeHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_authentication_state(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.Security.AuthenticationStatus arg = authentication_state();
        _output = handler.createReply();
        org.omg.Security.AuthenticationStatusHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_mechanism(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        String arg = mechanism();
        _output = handler.createReply();
        org.omg.Security.MechanismTypeHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_accepting_options_supported(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        short arg = accepting_options_supported();
        _output = handler.createReply();
        org.omg.Security.AssociationOptionsHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__set_accepting_options_supported(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        short result = org.omg.Security.AssociationOptionsHelper.read(_is);

        accepting_options_supported(result);
        _output = handler.createReply();
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_accepting_options_required(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        short arg = accepting_options_required();
        _output = handler.createReply();
        org.omg.Security.AssociationOptionsHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__set_accepting_options_required(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        short result = org.omg.Security.AssociationOptionsHelper.read(_is);

        accepting_options_required(result);
        _output = handler.createReply();
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_invocation_options_supported(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        short arg = invocation_options_supported();
        _output = handler.createReply();
        org.omg.Security.AssociationOptionsHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__set_invocation_options_supported(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        short result = org.omg.Security.AssociationOptionsHelper.read(_is);

        invocation_options_supported(result);
        _output = handler.createReply();
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_invocation_options_required(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        short arg = invocation_options_required();
        _output = handler.createReply();
        org.omg.Security.AssociationOptionsHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__set_invocation_options_required(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        short result = org.omg.Security.AssociationOptionsHelper.read(_is);

        invocation_options_required(result);
        _output = handler.createReply();
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_get_security_feature(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.Security.CommunicationDirection arg0_in = org.omg.Security.CommunicationDirectionHelper.read(_is);
        org.omg.Security.SecurityFeature arg1_in = org.omg.Security.SecurityFeatureHelper.read(_is);

        boolean _arg_result = get_security_feature(arg0_in, arg1_in);

        _output = handler.createReply();
        _output.write_boolean(_arg_result);

        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_set_attributes(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.Security.SecAttribute[] arg0_in = org.omg.Security.AttributeListHelper.read(_is);
        org.omg.Security.AttributeListHolder arg1_out = new org.omg.Security.AttributeListHolder();

        boolean _arg_result = set_attributes(arg0_in, arg1_out);

        _output = handler.createReply();
        _output.write_boolean(_arg_result);

        org.omg.Security.AttributeListHelper.write(_output,arg1_out.value);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_get_attributes(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.Security.AttributeType[] arg0_in = org.omg.Security.AttributeTypeListHelper.read(_is);

        org.omg.Security.SecAttribute[] _arg_result = get_attributes(arg0_in);

        _output = handler.createReply();
        org.omg.Security.AttributeListHelper.write(_output,_arg_result);

        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_is_valid(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.TimeBase.UtcTHolder arg0_out = new org.omg.TimeBase.UtcTHolder();

        boolean _arg_result = is_valid(arg0_out);

        _output = handler.createReply();
        _output.write_boolean(_arg_result);

        org.omg.Security.UtcTHelper.write(_output,arg0_out.value);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_refresh(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.CORBA.Any arg0_in = _is.read_any();

        boolean _arg_result = refresh(arg0_in);

        _output = handler.createReply();
        _output.write_boolean(_arg_result);

        return _output;
    }

    // operation classes
    private abstract static class AbstractOperation {
        protected abstract org.omg.CORBA.portable.OutputStream invoke(
                CredentialsPOA target,
                org.omg.CORBA.portable.InputStream _is,
                org.omg.CORBA.portable.ResponseHandler handler);
    }

    private static final class Operation_copy extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_copy(_is, handler);
        }
    }

    private static final class Operation_destroy extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_destroy(_is, handler);
        }
    }

    private static final class Operation__get_credentials_type extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_credentials_type(_is, handler);
        }
    }

    private static final class Operation__get_authentication_state extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_authentication_state(_is, handler);
        }
    }

    private static final class Operation__get_mechanism extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_mechanism(_is, handler);
        }
    }

    private static final class Operation__get_accepting_options_supported extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_accepting_options_supported(_is, handler);
        }
    }

    private static final class Operation__set_accepting_options_supported extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__set_accepting_options_supported(_is, handler);
        }
    }

    private static final class Operation__get_accepting_options_required extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_accepting_options_required(_is, handler);
        }
    }

    private static final class Operation__set_accepting_options_required extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__set_accepting_options_required(_is, handler);
        }
    }

    private static final class Operation__get_invocation_options_supported extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_invocation_options_supported(_is, handler);
        }
    }

    private static final class Operation__set_invocation_options_supported extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__set_invocation_options_supported(_is, handler);
        }
    }

    private static final class Operation__get_invocation_options_required extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_invocation_options_required(_is, handler);
        }
    }

    private static final class Operation__set_invocation_options_required extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__set_invocation_options_required(_is, handler);
        }
    }

    private static final class Operation_get_security_feature extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_get_security_feature(_is, handler);
        }
    }

    private static final class Operation_set_attributes extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_set_attributes(_is, handler);
        }
    }

    private static final class Operation_get_attributes extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_get_attributes(_is, handler);
        }
    }

    private static final class Operation_is_valid extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_is_valid(_is, handler);
        }
    }

    private static final class Operation_refresh extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final CredentialsPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_refresh(_is, handler);
        }
    }

}
