package org.omg.SecurityLevel2;

/**
 * Interface definition : PrincipalAuthenticator
 * 
 * @author OpenORB Compiler
 */
public abstract class PrincipalAuthenticatorPOA extends org.omg.PortableServer.Servant
        implements PrincipalAuthenticatorOperations, org.omg.CORBA.portable.InvokeHandler
{
    public PrincipalAuthenticator _this()
    {
        return PrincipalAuthenticatorHelper.narrow(_this_object());
    }

    public PrincipalAuthenticator _this(org.omg.CORBA.ORB orb)
    {
        return PrincipalAuthenticatorHelper.narrow(_this_object(orb));
    }

    private static String [] _ids_list =
    {
        "IDL:omg.org/SecurityLevel2/PrincipalAuthenticator:1.8"
    };

    public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte [] objectId)
    {
        return _ids_list;
    }

    public final org.omg.CORBA.portable.OutputStream _invoke(final String opName,
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler)
    {

        if (opName.equals("authenticate")) {
                return _invoke_authenticate(_is, handler);
        } else if (opName.equals("continue_authentication")) {
                return _invoke_continue_authentication(_is, handler);
        } else if (opName.equals("get_supported_authen_methods")) {
                return _invoke_get_supported_authen_methods(_is, handler);
        } else {
            throw new org.omg.CORBA.BAD_OPERATION(opName);
        }
    }

    // helper methods
    private org.omg.CORBA.portable.OutputStream _invoke_get_supported_authen_methods(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        String arg0_in = org.omg.Security.MechanismTypeHelper.read(_is);

        int[] _arg_result = get_supported_authen_methods(arg0_in);

        _output = handler.createReply();
        org.omg.Security.AuthenticationMethodListHelper.write(_output,_arg_result);

        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_authenticate(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        int arg0_in = org.omg.Security.AuthenticationMethodHelper.read(_is);
        String arg1_in = org.omg.Security.MechanismTypeHelper.read(_is);
        String arg2_in = org.omg.Security.SecurityNameHelper.read(_is);
        org.omg.CORBA.Any arg3_in = _is.read_any();
        org.omg.Security.SecAttribute[] arg4_in = org.omg.Security.AttributeListHelper.read(_is);
        org.omg.SecurityLevel2.CredentialsHolder arg5_out = new org.omg.SecurityLevel2.CredentialsHolder();
        org.omg.CORBA.AnyHolder arg6_out = new org.omg.CORBA.AnyHolder();
        org.omg.CORBA.AnyHolder arg7_out = new org.omg.CORBA.AnyHolder();

        org.omg.Security.AuthenticationStatus _arg_result = authenticate(arg0_in, arg1_in, arg2_in, arg3_in, arg4_in, arg5_out, arg6_out, arg7_out);

        _output = handler.createReply();
        org.omg.Security.AuthenticationStatusHelper.write(_output,_arg_result);

        org.omg.SecurityLevel2.CredentialsHelper.write(_output,arg5_out.value);
        _output.write_any(arg6_out.value);
        _output.write_any(arg7_out.value);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_continue_authentication(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.CORBA.Any arg0_in = _is.read_any();
        org.omg.SecurityLevel2.Credentials arg1_in = org.omg.SecurityLevel2.CredentialsHelper.read(_is);
        org.omg.CORBA.AnyHolder arg2_out = new org.omg.CORBA.AnyHolder();
        org.omg.CORBA.AnyHolder arg3_out = new org.omg.CORBA.AnyHolder();

        org.omg.Security.AuthenticationStatus _arg_result = continue_authentication(arg0_in, arg1_in, arg2_out, arg3_out);

        _output = handler.createReply();
        org.omg.Security.AuthenticationStatusHelper.write(_output,_arg_result);

        _output.write_any(arg2_out.value);
        _output.write_any(arg3_out.value);
        return _output;
    }

}
