package org.omg.SecurityLevel2;

/**
 * Interface definition : SecurityManager
 * 
 * @author OpenORB Compiler
 */
public abstract class SecurityManagerPOA extends org.omg.PortableServer.Servant
        implements SecurityManagerOperations, org.omg.CORBA.portable.InvokeHandler
{
    public SecurityManager _this()
    {
        return SecurityManagerHelper.narrow(_this_object());
    }

    public SecurityManager _this(org.omg.CORBA.ORB orb)
    {
        return SecurityManagerHelper.narrow(_this_object(orb));
    }

    private static String [] _ids_list =
    {
        "IDL:omg.org/SecurityLevel2/SecurityManager:1.8"
    };

    public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte [] objectId)
    {
        return _ids_list;
    }

    private static final java.util.Map operationMap = new java.util.HashMap();

    static {
            operationMap.put("_get_access_decision",
                    new Operation__get_access_decision());
            operationMap.put("_get_audit_decision",
                    new Operation__get_audit_decision());
            operationMap.put("_get_own_credentials",
                    new Operation__get_own_credentials());
            operationMap.put("_get_principal_authenticator",
                    new Operation__get_principal_authenticator());
            operationMap.put("_get_required_rights_object",
                    new Operation__get_required_rights_object());
            operationMap.put("_get_supported_mechanisms",
                    new Operation__get_supported_mechanisms());
            operationMap.put("get_security_policy",
                    new Operation_get_security_policy());
            operationMap.put("get_target_credentials",
                    new Operation_get_target_credentials());
            operationMap.put("remove_own_credentials",
                    new Operation_remove_own_credentials());
    }

    public final org.omg.CORBA.portable.OutputStream _invoke(final String opName,
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler)
    {

        final AbstractOperation operation = (AbstractOperation)operationMap.get(opName);

        if (null == operation) {
            throw new org.omg.CORBA.BAD_OPERATION(opName);
        }

        return operation.invoke(this, _is, handler);
    }

    // helper methods
    private org.omg.CORBA.portable.OutputStream _invoke__get_supported_mechanisms(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.Security.MechandOptions[] arg = supported_mechanisms();
        _output = handler.createReply();
        org.omg.Security.MechandOptionsListHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_own_credentials(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.SecurityLevel2.Credentials[] arg = own_credentials();
        _output = handler.createReply();
        org.omg.SecurityLevel2.CredentialsListHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_required_rights_object(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.SecurityLevel2.RequiredRights arg = required_rights_object();
        _output = handler.createReply();
        org.omg.SecurityLevel2.RequiredRightsHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_principal_authenticator(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.SecurityLevel2.PrincipalAuthenticator arg = principal_authenticator();
        _output = handler.createReply();
        org.omg.SecurityLevel2.PrincipalAuthenticatorHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_access_decision(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.SecurityLevel2.AccessDecision arg = access_decision();
        _output = handler.createReply();
        org.omg.SecurityLevel2.AccessDecisionHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke__get_audit_decision(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.SecurityLevel2.AuditDecision arg = audit_decision();
        _output = handler.createReply();
        org.omg.SecurityLevel2.AuditDecisionHelper.write(_output,arg);
        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_get_target_credentials(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.CORBA.Object arg0_in = _is.read_Object();

        org.omg.SecurityLevel2.TargetCredentials _arg_result = get_target_credentials(arg0_in);

        _output = handler.createReply();
        org.omg.SecurityLevel2.TargetCredentialsHelper.write(_output,_arg_result);

        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_remove_own_credentials(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        org.omg.SecurityLevel2.Credentials arg0_in = org.omg.SecurityLevel2.CredentialsHelper.read(_is);

        remove_own_credentials(arg0_in);

        _output = handler.createReply();

        return _output;
    }

    private org.omg.CORBA.portable.OutputStream _invoke_get_security_policy(
            final org.omg.CORBA.portable.InputStream _is,
            final org.omg.CORBA.portable.ResponseHandler handler) {
        org.omg.CORBA.portable.OutputStream _output;
        int arg0_in = org.omg.CORBA.PolicyTypeHelper.read(_is);

        org.omg.CORBA.Policy _arg_result = get_security_policy(arg0_in);

        _output = handler.createReply();
        org.omg.CORBA.PolicyHelper.write(_output,_arg_result);

        return _output;
    }

    // operation classes
    private abstract static class AbstractOperation {
        protected abstract org.omg.CORBA.portable.OutputStream invoke(
                SecurityManagerPOA target,
                org.omg.CORBA.portable.InputStream _is,
                org.omg.CORBA.portable.ResponseHandler handler);
    }

    private static final class Operation__get_supported_mechanisms extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_supported_mechanisms(_is, handler);
        }
    }

    private static final class Operation__get_own_credentials extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_own_credentials(_is, handler);
        }
    }

    private static final class Operation__get_required_rights_object extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_required_rights_object(_is, handler);
        }
    }

    private static final class Operation__get_principal_authenticator extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_principal_authenticator(_is, handler);
        }
    }

    private static final class Operation__get_access_decision extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_access_decision(_is, handler);
        }
    }

    private static final class Operation__get_audit_decision extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke__get_audit_decision(_is, handler);
        }
    }

    private static final class Operation_get_target_credentials extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_get_target_credentials(_is, handler);
        }
    }

    private static final class Operation_remove_own_credentials extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_remove_own_credentials(_is, handler);
        }
    }

    private static final class Operation_get_security_policy extends AbstractOperation
    {
        protected org.omg.CORBA.portable.OutputStream invoke(
                final SecurityManagerPOA target,
                final org.omg.CORBA.portable.InputStream _is,
                final org.omg.CORBA.portable.ResponseHandler handler) {
            return target._invoke_get_security_policy(_is, handler);
        }
    }

}
