package org.omg.SecurityLevel2;

/**
 * Interface definition : PrincipalAuthenticator
 * 
 * @author OpenORB Compiler
 */
public class _PrincipalAuthenticatorStub extends org.omg.CORBA.portable.ObjectImpl
        implements PrincipalAuthenticator
{
    static final String[] _ids_list =
    {
        "IDL:omg.org/SecurityLevel2/PrincipalAuthenticator:1.8"
    };

    public String[] _ids()
    {
     return _ids_list;
    }

    private final static Class _opsClass = org.omg.SecurityLevel2.PrincipalAuthenticatorOperations.class;

    /**
     * Operation get_supported_authen_methods
     */
    public int[] get_supported_authen_methods(String mechanism)
    {
        while(true)
        {
            if (!this._is_local())
            {
                org.omg.CORBA.portable.InputStream _input = null;
                try
                {
                    org.omg.CORBA.portable.OutputStream _output = this._request("get_supported_authen_methods",true);
                    org.omg.Security.MechanismTypeHelper.write(_output,mechanism);
                    _input = this._invoke(_output);
                    int[] _arg_ret = org.omg.Security.AuthenticationMethodListHelper.read(_input);
                    return _arg_ret;
                }
                catch(org.omg.CORBA.portable.RemarshalException _exception)
                {
                    continue;
                }
                catch(org.omg.CORBA.portable.ApplicationException _exception)
                {
                    String _exception_id = _exception.getId();
                    throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: "+ _exception_id);
                }
                finally
                {
                    this._releaseReply(_input);
                }
            }
            else
            {
                org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_supported_authen_methods",_opsClass);
                if (_so == null)
                   continue;
                org.omg.SecurityLevel2.PrincipalAuthenticatorOperations _self = (org.omg.SecurityLevel2.PrincipalAuthenticatorOperations) _so.servant;
                try
                {
                    return _self.get_supported_authen_methods( mechanism);
                }
                finally
                {
                    _servant_postinvoke(_so);
                }
            }
        }
    }

    /**
     * Operation authenticate
     */
    public org.omg.Security.AuthenticationStatus authenticate(int method, String mechanism, String security_name, org.omg.CORBA.Any auth_data, org.omg.Security.SecAttribute[] privileges, org.omg.SecurityLevel2.CredentialsHolder creds, org.omg.CORBA.AnyHolder continuation_data, org.omg.CORBA.AnyHolder auth_specific_data)
    {
        while(true)
        {
            if (!this._is_local())
            {
                org.omg.CORBA.portable.InputStream _input = null;
                try
                {
                    org.omg.CORBA.portable.OutputStream _output = this._request("authenticate",true);
                    org.omg.Security.AuthenticationMethodHelper.write(_output,method);
                    org.omg.Security.MechanismTypeHelper.write(_output,mechanism);
                    org.omg.Security.SecurityNameHelper.write(_output,security_name);
                    _output.write_any(auth_data);
                    org.omg.Security.AttributeListHelper.write(_output,privileges);
                    _input = this._invoke(_output);
                    org.omg.Security.AuthenticationStatus _arg_ret = org.omg.Security.AuthenticationStatusHelper.read(_input);
                    creds.value = org.omg.SecurityLevel2.CredentialsHelper.read(_input);
                    continuation_data.value = _input.read_any();
                    auth_specific_data.value = _input.read_any();
                    return _arg_ret;
                }
                catch(org.omg.CORBA.portable.RemarshalException _exception)
                {
                    continue;
                }
                catch(org.omg.CORBA.portable.ApplicationException _exception)
                {
                    String _exception_id = _exception.getId();
                    throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: "+ _exception_id);
                }
                finally
                {
                    this._releaseReply(_input);
                }
            }
            else
            {
                org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("authenticate",_opsClass);
                if (_so == null)
                   continue;
                org.omg.SecurityLevel2.PrincipalAuthenticatorOperations _self = (org.omg.SecurityLevel2.PrincipalAuthenticatorOperations) _so.servant;
                try
                {
                    return _self.authenticate( method,  mechanism,  security_name,  auth_data,  privileges,  creds,  continuation_data,  auth_specific_data);
                }
                finally
                {
                    _servant_postinvoke(_so);
                }
            }
        }
    }

    /**
     * Operation continue_authentication
     */
    public org.omg.Security.AuthenticationStatus continue_authentication(org.omg.CORBA.Any response_data, org.omg.SecurityLevel2.Credentials creds, org.omg.CORBA.AnyHolder continuation_data, org.omg.CORBA.AnyHolder auth_specific_data)
    {
        while(true)
        {
            if (!this._is_local())
            {
                org.omg.CORBA.portable.InputStream _input = null;
                try
                {
                    org.omg.CORBA.portable.OutputStream _output = this._request("continue_authentication",true);
                    _output.write_any(response_data);
                    org.omg.SecurityLevel2.CredentialsHelper.write(_output,creds);
                    _input = this._invoke(_output);
                    org.omg.Security.AuthenticationStatus _arg_ret = org.omg.Security.AuthenticationStatusHelper.read(_input);
                    continuation_data.value = _input.read_any();
                    auth_specific_data.value = _input.read_any();
                    return _arg_ret;
                }
                catch(org.omg.CORBA.portable.RemarshalException _exception)
                {
                    continue;
                }
                catch(org.omg.CORBA.portable.ApplicationException _exception)
                {
                    String _exception_id = _exception.getId();
                    throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: "+ _exception_id);
                }
                finally
                {
                    this._releaseReply(_input);
                }
            }
            else
            {
                org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("continue_authentication",_opsClass);
                if (_so == null)
                   continue;
                org.omg.SecurityLevel2.PrincipalAuthenticatorOperations _self = (org.omg.SecurityLevel2.PrincipalAuthenticatorOperations) _so.servant;
                try
                {
                    return _self.continue_authentication( response_data,  creds,  continuation_data,  auth_specific_data);
                }
                finally
                {
                    _servant_postinvoke(_so);
                }
            }
        }
    }

}
