package org.omg.SecurityReplaceable;

/**
 * Interface definition : Vault
 * 
 * @author OpenORB Compiler
 */
public interface VaultOperations
{
    /**
     * Operation get_supported_authen_methods
     */
    public int[] get_supported_authen_methods(String mechanism);

    /**
     * Read accessor for supported_mech_oids attribute
     * @return the attribute value
     */
    public byte[][] supported_mech_oids();

    /**
     * Operation acquire_credentials
     */
    public org.omg.Security.AuthenticationStatus acquire_credentials(int method, String mechanism, String security_name, org.omg.CORBA.Any auth_data, org.omg.Security.SecAttribute[] privileges, org.omg.SecurityLevel2.CredentialsHolder creds, org.omg.CORBA.AnyHolder continuation_data, org.omg.CORBA.AnyHolder auth_specific_data);

    /**
     * Operation continue_credentials_acquisition
     */
    public org.omg.Security.AuthenticationStatus continue_credentials_acquisition(org.omg.CORBA.Any response_data, org.omg.SecurityLevel2.Credentials creds, org.omg.CORBA.AnyHolder continuation_data, org.omg.CORBA.AnyHolder auth_specific_data);

    /**
     * Operation create_ior_components
     */
    public org.omg.IOP.TaggedComponent[] create_ior_components(org.omg.SecurityLevel2.Credentials creds_list);

    /**
     * Operation init_security_context
     */
    public org.omg.Security.AssociationStatus init_security_context(org.omg.SecurityLevel2.Credentials creds, String target_security_name, org.omg.CORBA.Object target, org.omg.Security.DelegationMode delegation_mode, org.omg.Security.OptionsDirectionPair[] association_options, String mechanism, byte[] comp_data, org.omg.Security.ChannelBindings chan_binding, org.omg.Security.OpaqueBufferHolder security_token, org.omg.SecurityReplaceable.ClientSecurityContextHolder security_context);

    /**
     * Operation accept_security_context
     */
    public org.omg.Security.AssociationStatus accept_security_context(org.omg.SecurityLevel2.Credentials[] creds_list, org.omg.Security.ChannelBindings chan_bindings, org.omg.Security.OpaqueBuffer in_token, org.omg.Security.OpaqueBufferHolder out_token, org.omg.SecurityReplaceable.ServerSecurityContextHolder security_context);

    /**
     * Operation get_supported_mechs
     */
    public org.omg.Security.MechandOptions[] get_supported_mechs();

}
